# Tags

Build html elements by tag name in [Dart][dart].

[![Build Status](https://drone.io/github.com/rmsmith/tags/status.png)][badge]

## Build Html Fluently

Tags makes it easy to build trees of html elements in code.  Consider an 
example:

```dart
import 'package:tags/html.dart';

main() {
  document.body.append(
    ul(() {
      li()..text = 'Coffee';
      li()..text = 'Tea';
      li()..text = 'Milk';
    }));
}
```

## Define Custom Tags

Tags allows you to extend html and define your own custom tags!

```dart
import 'package:tags/custom.dart';
import 'package:tags/html.dart';

main() {
  document.body.append(
    div(() {
      toggleButton(() {
          span()..text = 'up'..classes = ['up'];
          span()..text = 'down'..classes = ['down'];
        });
    }));
}    
```

By defining a custom tag such as `toggleButton` you may build trees of elements 
that contain not only the standard html elements but also your own (and other
people's!) custom tags.

_NOTE:_ We are watching closely the development of the [custom elements][]
specification, and our custom tags will become imperative custom elements as
soon as that is possible in `dart:html`.

_Tags uses the MIT license as described in the [LICENSE][license] file, and 
follows [semantic versioning][]._

[badge]: https://drone.io/github.com/rmsmith/tags/latest
[custom elements]: http://www.w3.org/TR/2013/WD-custom-elements-20130514/
[dart]: http://www.dartlang.org/
[license]: https://github.com/rmsmith/tags/blob/master/LICENSE
[semantic versioning]: http://semver.org/
